# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
from .agent_export import AgentExport
from ...commons.types.pagination import Pagination
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic


class ListAgentExportsResponse(UniversalBaseModel):
    """
    Examples
    --------
    import datetime

    from flatfile.agent_exports import AgentExport, ListAgentExportsResponse
    from flatfile.commons import Pagination

    ListAgentExportsResponse(
        data=[
            AgentExport(
                id="us_agx_YOUR_ID",
                agent_id="us_ag_YOUR_ID",
                export_type="AUTOBUILD_INLINED",
                account_id="us_acc_YOUR_ID",
                environment_id="us_env_YOUR_ID",
                created_at=datetime.datetime.fromisoformat(
                    "2023-10-30 16:59:45.735000+00:00",
                ),
                updated_at=datetime.datetime.fromisoformat(
                    "2023-10-30 16:59:45.735000+00:00",
                ),
            )
        ],
        pagination=Pagination(
            current_page=3,
            page_count=50,
            total_count=100,
        ),
    )
    """

    data: typing.List[AgentExport]
    pagination: Pagination

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
