# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from ...commons.types.action import Action
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class DocumentConfig(UniversalBaseModel):
    """
    Examples
    --------
    from flatfile.commons import Action
    from flatfile.documents import DocumentConfig

    DocumentConfig(
        title="My Document 1",
        body="My information",
        actions=[
            Action(
                operation="submitAction",
                mode="foreground",
                label="Submit",
                description="Submit data to webhook.site",
                primary=True,
            )
        ],
    )
    """

    title: str
    body: str
    treatments: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    Certain treatments will cause your Document to look or behave differently.
    """

    actions: typing.Optional[typing.List[Action]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
