# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ...core.serialization import FieldMetadata
from .guest_authentication_enum import GuestAuthenticationEnum
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class EnvironmentConfigUpdate(UniversalBaseModel):
    """
    Properties used to update an environment

    Examples
    --------
    from flatfile.environments import EnvironmentConfigUpdate

    EnvironmentConfigUpdate(
        name="dev",
        is_prod=False,
        guest_authentication=["magic_link"],
        metadata={"key": "value"},
        namespaces=["default"],
    )
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the environment
    """

    is_prod: typing_extensions.Annotated[typing.Optional[bool], FieldMetadata(alias="isProd")] = pydantic.Field(
        default=None
    )
    """
    Whether or not the environment is a production environment
    """

    guest_authentication: typing_extensions.Annotated[
        typing.Optional[typing.List[GuestAuthenticationEnum]], FieldMetadata(alias="guestAuthentication")
    ] = None
    metadata: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = None
    translations_path: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="translationsPath")] = None
    namespaces: typing.Optional[typing.List[str]] = None
    language_override: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="languageOverride")] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
