# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .guide_resource import GuideResource
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import typing
import pydantic


class GuideDetailResponse(UniversalBaseModel):
    """
    Examples
    --------
    import datetime

    from flatfile.environments import GuideDetailResponse, GuideResource

    GuideDetailResponse(
        data=GuideResource(
            id="us_gu_YOUR_ID",
            description="Getting started guide",
            title="Importing your data",
            slug="getting-started",
            versions=[],
            blocks=[],
            metadata={"category": "onboarding"},
            created_at=datetime.datetime.fromisoformat(
                "2023-10-30 16:59:45.735000+00:00",
            ),
            updated_at=datetime.datetime.fromisoformat(
                "2023-10-30 16:59:45.735000+00:00",
            ),
        ),
    )
    """

    data: GuideResource

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
