# This file was auto-generated by Fern from our API Definition.

from .record_base import RecordBase
from .record_data import RecordData
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import typing
import pydantic


class Record(RecordBase):
    """
    A single row of data in a Sheet

    Examples
    --------
    from flatfile.records import CellValue, Record, RecordConfig

    Record(
        id="us_rc_YOUR_ID",
        version_id="us_vr_YOUR_ID",
        commit_id="us_vr_YOUR_ID",
        values={
            "firstName": CellValue(
                value="John",
                messages=[],
                valid=True,
            ),
            "lastName": CellValue(
                value="Smith",
                messages=[],
                valid=True,
            ),
            "email": CellValue(
                value="john.smith@example.com",
                messages=[],
                valid=True,
            ),
        },
        valid=True,
        metadata={},
        config=RecordConfig(),
    )
    """

    values: RecordData

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
