# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
from .snapshot import Snapshot
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import typing
import pydantic


class SnapshotResponse(UniversalBaseModel):
    """
    Examples
    --------
    import datetime

    from flatfile.property import Property_String
    from flatfile.sheets import SheetConfig
    from flatfile.snapshots import (
        Snapshot,
        SnapshotResponse,
        SnapshotSummary,
        SummarySection,
    )

    SnapshotResponse(
        data=Snapshot(
            id="us_ss_YOUR_ID",
            sheet_id="us_sh_YOUR_ID",
            label="My snapshot",
            summary=SnapshotSummary(
                created_since=SummarySection(
                    total=0,
                ),
                updated_since=SummarySection(
                    total=5,
                    by_field={"lastName": 5},
                ),
                deleted_since=SummarySection(
                    total=5,
                    by_field={"firstName": 1},
                ),
                schema_diff={
                    "firstName": "added",
                    "lastName": "removed",
                    "email": "unchanged",
                },
                config=SheetConfig(
                    name="Contacts",
                    slug="contacts",
                    fields=[
                        Property_String(
                            key="firstName",
                            label="First Name",
                        ),
                        Property_String(
                            key="lastName",
                            label="Last Name",
                        ),
                        Property_String(
                            key="email",
                            label="Email",
                        ),
                    ],
                    mapping_confidence_threshold=0.5,
                ),
            ),
            created_at=datetime.datetime.fromisoformat(
                "2023-01-01 00:00:00+00:00",
            ),
            created_by="us_usr_YOUR_ID",
        ),
    )
    """

    data: Snapshot

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
