# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
from ...commons.types.pagination import Pagination
from .space import Space
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic


class ListSpacesResponse(UniversalBaseModel):
    """
    List of Space objects

    Examples
    --------
    import datetime

    from flatfile.commons import Pagination
    from flatfile.spaces import ListSpacesResponse, Space

    ListSpacesResponse(
        pagination=Pagination(
            current_page=3,
            page_count=50,
            total_count=100,
        ),
        data=[
            Space(
                id="us_sp_YOUR_ID",
                name="My First Worbook",
                display_order=1,
                created_at=datetime.datetime.fromisoformat(
                    "2021-01-01 00:00:00+00:00",
                ),
                updated_at=datetime.datetime.fromisoformat(
                    "2021-01-01 00:00:00+00:00",
                ),
                last_activity_at=datetime.datetime.fromisoformat(
                    "2021-01-01 00:00:00+00:00",
                ),
                created_by_user_id="us_usr_YOUR_ID",
                workbooks_count=1,
                files_count=1,
                is_collaborative=True,
                upgraded_at=datetime.datetime.fromisoformat(
                    "2021-01-01 00:00:00+00:00",
                ),
                guest_authentication=["magic_link", "shared_link"],
                environment_id="us_env_YOUR_ID",
                primary_workbook_id="us_wb_YOUR_ID",
                labels=[],
            )
        ],
    )
    """

    pagination: typing.Optional[Pagination] = None
    data: typing.List[Space]

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
